package com.cours.examples;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 *
 * @author Administrateur
 */
public class Voiture extends Vehicule {

	private static final Log log = LogFactory.getLog(Vehicule.class);
    private int longueurParchoque;

    public Voiture(String marque, String couleur, int annee, double taille, boolean estAssure, int longueurParchoque) {
        super(marque, couleur, annee, taille, estAssure);
        this.longueurParchoque = longueurParchoque;
        log.debug("Contructeur Voiture(string,string,int,double,bool,int)");
    }

    // methode descriptionVehicule
    @Override
    public void descriptionVehicule() {
    	log.debug(String.format("Votre voiture peut être décrit de la façon suivante : [%s,longueurParchoque=%s]", super.toString(), longueurParchoque));
    }

    public int getLongueurParchoque() {
        return longueurParchoque;
    }

    public void setLongueurParchoque(int longueurParchoque) {
        this.longueurParchoque = longueurParchoque;
    }
}
