package com.cours.examples;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

/**
 *
 * @author ElHadji
 */
public class Voiture4X4 extends Voiture {

	private static final Log log = LogFactory.getLog(Voiture4X4.class);
	public double puissanceMoteurArriere;

	public Voiture4X4(String marque, String couleur, int annee, double taille, boolean estAssure, int longueurParchoque,
			double puissanceMoteurArriere) {
		super(marque, couleur, annee, taille, estAssure, longueurParchoque);
		this.puissanceMoteurArriere = puissanceMoteurArriere;
		log.debug("Contructeur Voiture4X4(string,string,int,double,bool,int,double)");
	}

	@Override
	public void descriptionVehicule() {
		log.debug(String.format(
				"Votre voiture 4X4 peut être décrit de la façon suivante : [%s,puissanceMoteurArriere=%s]",
				super.toString(), puissanceMoteurArriere));
	}

	public double getPuissanceMoteurArriere() {
		return puissanceMoteurArriere;
	}

	public void setPuissanceMoteurArriere(double puissanceMoteurArriere) {
		this.puissanceMoteurArriere = puissanceMoteurArriere;
	}
}
