package com.cours.main;

import org.apache.commons.logging.Log;
import org.apache.commons.logging.LogFactory;

import com.cours.examples.Animal;
import com.cours.examples.Vehicule;
import com.cours.examples.Voiture;
import com.cours.examples.Voiture4X4;
import com.cours.helper.ReflexiveHelper;

public class MainApp {
	private static final Log log = LogFactory.getLog(MainApp.class);
	private static ReflexiveHelper reflexiveHelper = new ReflexiveHelper();

	public static void main(String ...args) {
		log.debug("************* Debut ************");
		Vehicule myVehicule = new Vehicule("Ma Marque Vehicule", "Ma Couleur Vehicule", 2000, 200.0, true);
		Voiture toyota = new Voiture("Toyota", "Gris", 2000, 200.0, true, 50);
		Voiture4X4 bmw = new Voiture4X4("BMW 4x4", "Blanche", 2000, 200.0, true, 50, 500);
		Animal lion = new Animal("Lion", "Maron", 200);
		//reflexiveHelper.displayStringClassInformations();
		//reflexiveHelper.displayClassInformations(toyota);
		// reflexiveHelper.displayPackage(toyota);
		//reflexiveHelper.displaySuperClasses(bmw);
		// reflexiveHelper.displayInterfaces(lion);
		// reflexiveHelper.displayMethodInformations(toyota);
		//Class<?> parameterTypesSetMarque = String.class;
		//reflexiveHelper.displayMethodInformations(toyota, "setMarque", parameterTypesSetMarque);
		
		//Class<?> parameterTypesSetCouleur= String.class;
		//reflexiveHelper.displayMethodInformations(toyota, "setCouleur", parameterTypesSetCouleur);
		
		//Class<?> parameterTypesSetTaille= double.class;
		//reflexiveHelper.displayMethodInformations(toyota, "setTaille", parameterTypesSetTaille);
		
		//reflexiveHelper.displayMethodInformations(toyota, "getMarque", null);
		
		reflexiveHelper.displayAllFields(bmw);
		//reflexiveHelper.displayAllDeclaredFields(bmw);
		
		// Voiture toyota
		//Class<?>[] toyotaParameterType = new Class [] {String.class,String.class,int.class,double.class,boolean.class,int.class};
		//reflexiveHelper.displayAllConstructors(toyota,toyotaParameterType);
		
		// Voiture4X4 bmw
		//Class<?>[] bmwParameterType = new Class [] {String.class,String.class,int.class,double.class,boolean.class,int.class,double.class};
		//reflexiveHelper.displayAllConstructors(bmw,bmwParameterType);
		//reflexiveHelper.instanciateVehiculeWithoutArgument();
		//reflexiveHelper.instanciateVehiculeWithArgument("BMW", "Noire","com.cours.examples.Vehicule");
		
		//reflexiveHelper.modifyVehicule(myVehicule,"Mon Vehicule Modifie", "Ma Couleur Vehicule Modifie");
		//reflexiveHelper.modifyVehicule(toyota,"Toyota Modifie", "Gris Modifie");
		//reflexiveHelper.modifyVehicule(bmw,"BMW Modifie", "Noire Modifie");
		//reflexiveHelper.invokeStaticMethod("com.cours.examples.Vehicule","BMW", "Noire");
		//reflexiveHelper.invokeStaticMethodAbsMath();
		reflexiveHelper.getFieldsWithAnnotation(myVehicule);
		log.debug("************* Fin ************");
	}
}
